import 'dart:core';
import "dart:typed_data";
import 'package:dart_chainsql_api/src/utils/Util.dart';

import "../serialized/SerializedType.dart";
import "../fields/Type.dart";
import "../serialized/BytesSink.dart";
import "../serialized/TypeTranslator.dart";
import 'package:dart_chainsql_api/src/core/serialized/BinaryParser.dart';

class Blob implements SerializedType {
  Blob(Uint8List bytes) {
    buffer = bytes;
  }

  Uint8List buffer;
  static BlobTranslator translate = new BlobTranslator();

  Map toJSON() => null;

  Uint8List toBytes() => buffer;

  String toHex() => null;

  void toBytesSink(BytesSink to) => translate.toBytesSink(this, to);

  Type type() => Type.Blob;
}

class BlobTranslator extends TypeTranslator<Blob> {
  Blob fromParser(BinaryParser parser, int hint) {
    if (hint == null) {
      hint = parser.getSize() - parser.pos();
    }
    return new Blob(parser.read(hint));
  }

  Blob fromString(String value) {
    return new Blob(Util.createUint8ListFromString(value));
  }

  void toBytesSink(Blob obj, BytesSink to) {
    to.addBytes(obj.buffer);
  }

//TODO
//  String toString(Blob obj) {
//    return B16.toString(obj.buffer);
//  }

//  Blob fromParser(BinaryParser parser, int hint) {
//    if (hint == null) {
//      hint = parser.size() - parser.pos();
//    }
//    return new Blob(parser.read(hint));
//  }

}
